import { IOptionsConstructor, ShieldRule } from 'graphql-shield/dist/types';
import { GetGen } from '@nexus/schema/dist/core';
declare type GenTypes = Extract<keyof GetGen<'fieldTypes'>, string>;
declare type GenFields<T extends GenTypes> = Extract<keyof GetGen<'fieldTypes'>[T], string>;
export declare type IRuleTypeMap = {
    [T in GenTypes]?: ShieldRule | IRuleFieldMap<T>;
};
export declare type IRuleFieldMap<T extends GenTypes> = {
    [F in GenFields<T>]?: ShieldRule;
} & {
    '*'?: ShieldRule;
};
export declare type IRules = ShieldRule | IRuleTypeMap;
export interface Settings {
    rules: IRules;
    options?: IOptionsConstructor;
}
export {};
